Thread (14 messages) flat view 14 messages, 4 authors, 2016-06-15

Re: [PATCH/RFC] test-lib: add support for colors without tput

From: Erik Faye-Lund <hidden>
Date: 2016-06-15 22:54:45
Subsystem: the rest · Maintainer: Linus Torvalds

On Fri, Sep 14, 2012 at 6:54 PM, Erik Faye-Lund [off-list ref] wrote:
quoted hunk ↗ jump to hunk
On Fri, Sep 14, 2012 at 6:41 PM, Erik Faye-Lund [off-list ref] wrote:
quoted
diff --git a/t/test-lib.sh b/t/test-lib.sh
index 78c4286..7d1b34b 100644
--- a/t/test-lib.sh
+++ b/t/test-lib.sh
@@ -129,6 +129,20 @@ export _x05 _x40 _z40 LF
 # This test checks if command xyzzy does the right thing...
 # '
 # . ./test-lib.sh
+
+if ! which tput > /dev/null ; then
+       tput () {
+               case "$1" in
+               bold)
+                       echo -ne "\033[1m" ;;
+               setaf)
+                       echo -ne "\033[0;3$2m" ;;
+               sgr0)
+                       echo -ne "\033(\033[m" ;;
I should of course have checked this earlier, but I find now that
"echo -ne" isn't portable. So perhaps this on top?
diff --git a/t/test-lib.sh b/t/test-lib.sh
index 7d1b34b..91a1d7b 100644
--- a/t/test-lib.sh
+++ b/t/test-lib.sh
@@ -134,11 +134,11 @@ if ! which tput > /dev/null ; then
        tput () {
                case "$1" in
                bold)
-                       echo -ne "\033[1m" ;;
+                       printf "%b" "\033[1m" ;;
                setaf)
-                       echo -ne "\033[0;3$2m" ;;
+                       printf "%b" "\033[0;3$2m" ;;
                sgr0)
-                       echo -ne "\033(\033[m" ;;
+                       printf "%b" "\033(\033[m" ;;
                esac
        }
 fi
And again, I'm stupid for not reading documentation properly; octal
escaped strings in the format string should work (and does on my
systems), so this is sufficient:
diff --git a/t/test-lib.sh b/t/test-lib.sh
index 7d1b34b..2a6149e 100644
--- a/t/test-lib.sh
+++ b/t/test-lib.sh
@@ -134,11 +134,11 @@ if ! which tput > /dev/null ; then
 	tput () {
 		case "$1" in
 		bold)
-			echo -ne "\033[1m" ;;
+			printf "\033[1m" ;;
 		setaf)
-			echo -ne "\033[0;3$2m" ;;
+			printf "\033[0;3$2m" ;;
 		sgr0)
-			echo -ne "\033(\033[m" ;;
+			printf "\033(\033[m" ;;
 		esac
 	}
 fi
-- 
*** Please reply-to-all at all times ***
*** (do not pretend to know who is subscribed and who is not) ***
*** Please avoid top-posting. ***
The msysGit Wiki is here: https://github.com/msysgit/msysgit/wiki - Github accounts are free.

You received this message because you are subscribed to the Google
Groups "msysGit" group.
To post to this group, send email to msysgit@googlegroups.com
To unsubscribe from this group, send email to
msysgit+unsubscribe@googlegroups.com
For more options, and view previous threads, visit this group at
http://groups.google.com/group/msysgit?hl=en_US?hl=en
Keyboard shortcuts
hback out one level
jnext message in thread
kprevious message in thread
ldrill in
Escclose help / fold thread tree
?toggle this help